scala.tools.nsc.Global

# icodeCheckers

#### object icodeCheckers extends ICodeCheckers

Icode verification

Source
  Global.scala

Linear Supertypes
ICodeCheckers, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. icodeCheckers
2. ICodeCheckers
3. AnyRef
4. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### class ICodeChecker extends AnyRef

   This class performs a set of checks similar to what the bytecode verifier does.

   This class performs a set of checks similar to what the bytecode verifier does. For each basic block, it checks that:

   - for primitive operations: the type and numer of operands match the type of the operation

   - for method calls: the method exists in the type of the receiver and the number and type of arguments match the declared type of the method.

   - for object creation: the constructor can be called.

   - for load/stores: the field/local/param exists and the type of the value matches that of the target.

   For a control flow graph it checks that type stacks at entry to each basic block 'agree':

   - they have the same length
   - there exists a lub for all types at the same position in stacks.
   Definition Classes
     ICodeCheckers
   Version

     1.0, 06/09/2005

   To do

     Iulian says: I think there's some outdated logic in the checker. The issue with exception handlers being special for least upper bounds pointed out some refactoring in the lattice class. Maybe a worthwhile refactoring would be to make the checker use the DataFlowAnalysis class, and use the lattice trait. In the implementation of LUB, there's a flag telling if one of the successors is 'exceptional'. The inliner is using this mechanism.

     ,

     Better checks for `MONITOR_ENTER/EXIT` Better checks for local var initializations

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

5. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

6. #### final def eq(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### def equals(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

8. #### def finalize(): Unit

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( classOf[java.lang.Throwable] )

9. #### final def getClass(): Class[_]

   Definition Classes
     AnyRef → Any

10. #### val global: Global.this.type

    Definition Classes
      icodeCheckers → ICodeCheckers

11. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

12. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

13. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

14. #### final def notify(): Unit

    Definition Classes
      AnyRef

15. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

16. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

17. #### def toString(): String

    Definition Classes
      AnyRef → Any

18. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

19. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

20. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from ICodeCheckers

### Inherited from AnyRef

### Inherited from Any

### Ungrouped